package opendap.conf;

import opendap.coreServlet.Scrub;
import opendap.coreServlet.ServletUtil;
import org.jdom.Document;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.servlet.ServletException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.concurrent.locks.ReentrantLock;

public class ConfigManager {

    private Logger log;
    private  AtomicBoolean IS_INITIALIZED = new AtomicBoolean(false);
    private  ReentrantLock INIT_LOCK = new ReentrantLock();

    private Document configDoc;

    private ConfigManager(String configurationFile) throws JDOMException, IOException {
        log = LoggerFactory.getLogger(this.getClass());
        loadConfig(configurationFile);
    }

    ConfigManager theCM(){
    return null;
    }

    /**
     * Loads the configuration file specified in the servlet parameter
     * ConfigFileName.
     *
     * @throws ServletException When the file is missing, unreadable, or fails
     *                          to parse (as an XML document).
     */
    private void loadConfig(String filename)  throws JDOMException, IOException{

        String errorMsgBase = "OLFS configuration file \"";

        log.debug("Loading Configuration File: {}", filename);
        try {

            File confFile = new File(filename);
            FileInputStream fis = new FileInputStream(confFile);

            try {
                // Parse the XML doc into a Document object.
                SAXBuilder sb = new SAXBuilder();
                configDoc = sb.build(fis);
            } finally {
                fis.close();
            }

        } catch (FileNotFoundException e) {
            String msg = errorMsgBase + filename + "\" cannot be found.";
            log.error(msg);
            throw e;
        } catch (IOException e) {
            String msg = errorMsgBase + filename + "\" is not readable.";
            log.error(msg);
            throw e;
        } catch (JDOMException e) {
            String msg = errorMsgBase + filename + "\" cannot be parsed.";
            log.error(msg);
            throw e;
        }

        log.debug("Configuration loaded and parsed from {}",filename);
    }

}
